# Mutations

- [activateSubscription](https://developer.firmhouse.com/graphql-api/api-reference/mutations/activate-subscription.md): Activates an inactive subscription.
- [applyPromotionToSubscription](https://developer.firmhouse.com/graphql-api/api-reference/mutations/apply-promotion-to-subscription.md): Applies a promotion to a subscription.
- [assignAsset](https://developer.firmhouse.com/graphql-api/api-reference/mutations/assign-asset.md): Assign asset to a subscription.
- [bulkUpdateOrderLines](https://developer.firmhouse.com/graphql-api/api-reference/mutations/bulk-update-order-lines.md): Updates multiple order lines at once. Allows changing the quantity and product for all specified order lines.
- [cancelReturnOrder](https://developer.firmhouse.com/graphql-api/api-reference/mutations/cancel-return-order.md): Cancels an 'in progress' return order.
- [cancelScheduledOrder](https://developer.firmhouse.com/graphql-api/api-reference/mutations/cancel-scheduled-order.md): Cancels a scheduled order by setting its status to cancelled and clearing the shipment date.
- [cancelSubscription](https://developer.firmhouse.com/graphql-api/api-reference/mutations/cancel-subscription.md): Cancels a subscription or initiates cancellation when two-step cancellation is enabled on your project.
- [chargeShopifyOrderOutstandingAmount](https://developer.firmhouse.com/graphql-api/api-reference/mutations/charge-shopify-order-outstanding-amount.md): Charges the outstanding amount on a Shopify order using the totalOutstandingSet value from the Shopify API.
- [completeReturnOrder](https://developer.firmhouse.com/graphql-api/api-reference/mutations/complete-return-order.md): Completes an 'in progress' return order.
- [completeSubscriptionCancellation](https://developer.firmhouse.com/graphql-api/api-reference/mutations/complete-subscription-cancellation.md): Completes the subscription cancellation process (only available when two-step cancellation is enabled on your project).
- [createAsset](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-asset.md): Creates an asset for a product, optionally assigns it to a subscription.
- [createCart](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-cart.md): Creates an empty draft/cart subscription.
- [createDiscountCode](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-discount-code.md): Creates a discount code
- [createFreeOrderLine](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-free-order-line.md): Adds a free order line to an existing order. Only scheduled orders can be updated; other statuses will cause the mutation
- [createInvoiceLineItem](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-invoice-line-item.md): Creates an invoice line item for an invoice.
- [createInvoicedOneTimeCharge](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-invoiced-one-time-charge.md): Immediately charges and invoices the given amount
- [createOrder](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-order.md): Deprecated: The behavior of this mutation will be changed significantly soon.
- [createOrderedProduct](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-ordered-product.md): Deprecated: Use CreateOrderedProductV2 instead.
- [createOrderedProductV2](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-ordered-product-v-2.md): Creates an ordered product on subscription identified via \`X-Subscription-Token\` or \`X-Project-Access-Token\`.
- [createProduct](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-product.md): Creates a product.
- [createProductGroup](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-product-group.md): Creates a product group.
- [createPromotion](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-promotion.md): Creates a promotion.
- [createReturnOrder](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-return-order.md): Creates a return order for the subscription.
- [createSelfServiceCenterLoginToken](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-self-service-center-login-token.md): Deprecated: This mutation is deprecated. If you would like to send an email with a link to the self service center, please use the \`sendSelfServiceCenterLoginTokenEmail\` mutation. If you need to creat
- [createSelfServiceCenterLoginTokenV2](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-self-service-center-login-token-v-2.md): Creates and returns a SelfServiceCenterLoginToken.
- [createServiceChannel](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-service-channel.md): Creates a service channel.
- [createSubscription](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-subscription.md): Creates a new subscription and returns payment redirection URLs.
- [createSubscriptionFromCart](https://developer.firmhouse.com/graphql-api/api-reference/mutations/create-subscription-from-cart.md): Finalises a subscription and returns payment details based on a cart/draft subscription identified by \`X-Subscription-Token\`.
- [creditAndRefundInvoice](https://developer.firmhouse.com/graphql-api/api-reference/mutations/credit-and-refund-invoice.md): Immediately creates a credit invoice and a tries to create a refund for the full amount of the original invoice
- [deactivateAppliedPromotion](https://developer.firmhouse.com/graphql-api/api-reference/mutations/deactivate-applied-promotion.md): Deactivates an applied promotion.
- [destroyDiscountCode](https://developer.firmhouse.com/graphql-api/api-reference/mutations/destroy-discount-code.md): Destroys a discount code (validation prevents removal if already applied)
- [destroyInvoiceLineItem](https://developer.firmhouse.com/graphql-api/api-reference/mutations/destroy-invoice-line-item.md): Destroys an invoice line item.
- [destroyOrderedProduct](https://developer.firmhouse.com/graphql-api/api-reference/mutations/destroy-ordered-product.md): Deletes an ordered product from the subscription identified via \`X-Subscription-Token\` or when authenticated through a project write token.
- [destroyProductGroup](https://developer.firmhouse.com/graphql-api/api-reference/mutations/destroy-product-group.md): Destroys a product group.
- [editPlan](https://developer.firmhouse.com/graphql-api/api-reference/mutations/edit-plan.md): Edits a plan.
- [fulfillOrder](https://developer.firmhouse.com/graphql-api/api-reference/mutations/fulfill-order.md): Marks an order as fulfilled. If Track\&Trace code is given in will also trigger Track\&Trace email.
- [fulfillOrders](https://developer.firmhouse.com/graphql-api/api-reference/mutations/fulfill-orders.md): Option to mark multiple orders as fulfilled at once, up to a maximum of 100 orders each time.
- [generateOfferForAssetOwnership](https://developer.firmhouse.com/graphql-api/api-reference/mutations/generate-offer-for-asset-ownership.md): Generates an asset purchase offer for the specified asset ownership.
- [importSubscription](https://developer.firmhouse.com/graphql-api/api-reference/mutations/import-subscription.md): Creates a subscription directly into the database without the need for a customer to signup, only use this when you're migrating from another platform.
- [pauseSubscription](https://developer.firmhouse.com/graphql-api/api-reference/mutations/pause-subscription.md): Pauses a subscription
- [pushOrdersToShopify](https://developer.firmhouse.com/graphql-api/api-reference/mutations/push-orders-to-shopify.md): Pushes orders to Shopify, this happens asynchronously.
- [refundPayment](https://developer.firmhouse.com/graphql-api/api-reference/mutations/refund-payment.md): Issues a refund for a payment. Some payment service providers may limit the maximum amount for or timeframe in which you can refund a payment.
- [rescheduleScheduledOrder](https://developer.firmhouse.com/graphql-api/api-reference/mutations/reschedule-scheduled-order.md): Reschedules a scheduled order to a new shipment date. If the order has a Shopify fulfillment order, a fulfillment reschedule job is enqueued.
- [resumeSubscription](https://developer.firmhouse.com/graphql-api/api-reference/mutations/resume-subscription.md): Resumes the subscription
- [retryFailedPayment](https://developer.firmhouse.com/graphql-api/api-reference/mutations/retry-failed-payment.md): Retries a failed payment and creates a new retry payment attempt.
- [sendSelfServiceCenterLoginTokenEmail](https://developer.firmhouse.com/graphql-api/api-reference/mutations/send-self-service-center-login-token-email.md): Creates a SelfServiceCenterLoginToken and sends an email to the customer's email address on file so they can log into their self service center.
- [shipOrderedProducts](https://developer.firmhouse.com/graphql-api/api-reference/mutations/ship-ordered-products.md): Immediately creates an order for the passed ordered products of the subscription. Any other ordered products of this subscription scheduled for today will also be shipped in the same order.
- [switchSubscriptionPlan](https://developer.firmhouse.com/graphql-api/api-reference/mutations/switch-subscription-plan.md): Initiates a plan switch offer for subscription.
- [syncShopifyProducts](https://developer.firmhouse.com/graphql-api/api-reference/mutations/sync-shopify-products.md): Syncs products from Shopify to Firmhouse.
- [unassignAsset](https://developer.firmhouse.com/graphql-api/api-reference/mutations/unassign-asset.md): Unassign asset from a subscription, this will mark the asset ownership as returned.
- [undoSubscriptionCancellation](https://developer.firmhouse.com/graphql-api/api-reference/mutations/undo-subscription-cancellation.md): Stops the subscription cancellation process (only available when two-step cancellation is enabled on your project).
- [updateAddressDetails](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-address-details.md): Updates certain information on the subscription identified via \`X-Subscription-Token\`
- [updateAppliedPromotion](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-applied-promotion.md): Updates a promotion applied to a Subscription
- [updateAsset](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-asset.md): Update an asset.
- [updateAssetOwnership](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-asset-ownership.md): Updates an asset ownership.
- [updateDiscountCode](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-discount-code.md): Updates a discount code (e.g., deactivate it or edit usage limits)
- [updateInvoice](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-invoice.md): Updates an invoice.
- [updateInvoiceLineItem](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-invoice-line-item.md): Updates an invoice line item.
- [updateOrder](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-order.md): Updates Order attributes. Only status, fulfilledAt timestamp, and trackingCode are allowed to be updated. Fulfillment process will not be triggered.
- [updateOrderLine](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-order-line.md): Updates an order line. Allows changing the quantity and product.
- [updateOrderedProduct](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-ordered-product.md): Updates the ordered product on a subscription identified via \`X-Subscription-Token\`.
- [updateOrderedProductQuantity](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-ordered-product-quantity.md): Updates an ordered product's quantity identified via \`X-Subscription-Token\`.
- [updatePlan](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-plan.md): Updates the active plan of the subscription identified via \`X-Subscription-Token\`.
- [updateProduct](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-product.md): Updates a product.
- [updateProductGroup](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-product-group.md): Updates a product group.
- [updatePromotion](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-promotion.md): Updates a promotion.
- [updateReturnOrder](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-return-order.md): Updates an 'in progress' return order.
- [updateSelfServiceCenterTemplate](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-self-service-center-template.md): Updates a Self Service Center V2 template.
- [updateShippingCostsExemption](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-shipping-costs-exemption.md): Updates the shipping costs exemption.
- [updateSubscribedPlan](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-subscribed-plan.md): Deprecated: This mutation is deprecated. Use \`updateSubscribedPlanV2\` for service-based plan switching behavior. Updates the subscribed plan.
- [updateSubscribedPlanV2](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-subscribed-plan-v-2.md): Updates the subscribed plan using plan switch service behavior.
- [updateSubscription](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-subscription.md): Updates a subscription.
- [updateSubscriptionAcceptanceCheck](https://developer.firmhouse.com/graphql-api/api-reference/mutations/update-subscription-acceptance-check.md): Updates the status or value of a subscription acceptance check.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developer.firmhouse.com/graphql-api/api-reference/mutations.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
